package com.jobs.consumer.controller;

import com.jobs.consumer.feignclient.ProviderAppClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RequestMapping("/consumer")
@RestController
public class ConsumerController {

    @Autowired
    private ProviderAppClient providerAppClient;

    //正常调用，返回正常结果
    @RequestMapping("/test1/{id}")
    public Map GetTest1(@PathVariable("id") int id) {

        Map result = providerAppClient.GetServerData(id);
        return result;
    }

    //服务端发生异常，在服务端降级，返回降级结果
    @RequestMapping("/test2/{id}")
    public Map GetTest2(@PathVariable("id") int id) {

        Map result = providerAppClient.GetServerError(id);
        return result;
    }

    //服务端处理业务逻辑超时，在服务端降级，返回降级结果
    @RequestMapping("/test3/{id}")
    public Map GetTest3(@PathVariable("id") int id) {

        Map result = providerAppClient.GetServerTimeOut1(id);
        return result;
    }

    //正常调用，返回正常结果
    @RequestMapping("/test4/{id}")
    public Map GetTest4(@PathVariable("id") int id) {

        Map result = providerAppClient.GetServerTimeOut2(id);
        return result;
    }
}
